externalize stabndalone server mode into file
authorpaul <paul@plutz.net>
Thu, 6 Oct 2016 21:29:30 +0000 (21:29 +0000)
committerpaul <paul@plutz.net>
Thu, 6 Oct 2016 21:29:30 +0000 (21:29 +0000)
svn path=/trunk/; revision=35

index.cgi
server.sh [new file with mode: 0755]

index 35795cb..c546b9a 100755 (executable)
--- a/index.cgi
+++ b/index.cgi
 
 export LC_ALL=C LANG=C
 
-if [ "$1" = '--ncat' ]; then
-  export REMOTE_ADDR="${NCAT_REMOTE_ADDR}"
-  export SERVER_NAME="${NCAT_LOCAL_ADDR}"
-  export SERVER_PORT="${NCAT_LOCAL_PORT}"
+# this program is supposed to be symlinked into a http root directory
+# we will use the http root as object storage (data directory) and call sub
+# programs from the directory in which the real executable resides
+# therefore we need to identify the code and data directories _EXEC and _DATA
+call="$0"
+real="$(readlink -f $call)"
+export _DATA="$(dirname "$call")"  #storage directory
+export _EXEC="${real%/shcgi/index.cgi}"  #execution directory
+
+if [ "$1" = '--server' -o  "$1" = '--inetd' -o "$1" = '--ncat' ]; then
+  . "$_EXEC/shcgi/server.sh" $@
 else
-  # this program is supposed to be symlinked into a http root directory
-  # we will use the http root as object storage (data directory) and call sub
-  # programs from the directory in which the real executable resides
-  # therefore we need to identify the code and data directories _EXEC and _DATA
-  call="$0"
-  real="$(readlink -f $call)"
-  _DATA="$(dirname "$call")"  #storage directory
-  _EXEC="${real%/shcgi/index.cgi}"  #execution directory
-  
-  . "$_EXEC/shcgi/misc.sh"
-  
-  # put debug options in the local.opts file
-  . "$_EXEC/shcgi/debug.sh"
-  [ -r "$_DATA/local.opts" ] && . "$_DATA/local.opts"
+  HTTP_format(){ cat }
 fi
-
-if [ "$1" = '--server' ]; then
-  shift 1
-  ncat -kle "$0 --ncat" $@
-  exit $?
-
-elif [ "$1" = '--inetd' -o "$1" = '--ncat' ]; then
-  eval $(
-  sed -nr '
-    /^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$/{
-      h
-      s;(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;export REQUEST_METHOD='\''\1'\'';p
-      g
-      s;(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;\2;
-      s;'\'';'\''\\'\'''\'';g
-      s;^.*$;export PATH_INFO='\''&'\'';p
-      g
-      s;(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;\3;
-      s;'\'';'\''\\'\'''\'';g
-      s;^.*$;export QUERY_STRING='\''&'\'';p
-      g
-      s;(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;export SERVER_PROTOCOL='\''\4'\'';p
-      g
-    }
   
-    /^[Pp][Rr][Oo][Xx][Yy]: /d
-  
-    /^[a-zA-Z_-]+: .*$/{
-      h
-      s;^[^:]+: (.*)\r$;\1;
-      s;'\'';'\''\\'\'''\'';g
-      s;^.*$;'\''&'\'';
-      x
-      s;: .*$;;
-      y;abcdefghijklmnopqrstuvwxyz-;ABCDEFGHIJKLMNOPQRSTUVWXYZ_;
-      s;^.+$;export HTTP_&=;
-      G
-      s;\n;;
-      p
-    }
-    /^\r?$/q
-  '
-  )
-fi
+. "$_EXEC/shcgi/misc.sh"
+
+# put debug options in the local.opts file
+. "$_EXEC/shcgi/debug.sh"
+[ -r "$_DATA/local.opts" ] && . "$_DATA/local.opts"
 
 . "$_EXEC/shcgi/cgi.sh"
 
@@ -102,4 +58,4 @@ else
   printf 'HTTP/1.1 404 Not Found\r\n'
   PAGE=error
   . "$_EXEC/shcgi/page.sh"
-fi
+fi |HTTP_format $@
diff --git a/server.sh b/server.sh
new file mode 100755 (executable)
index 0000000..dc97607
--- /dev/null
+++ b/server.sh
@@ -0,0 +1,86 @@
+#!/bin/zsh
+
+# Copyright 2016 Paul Hänsch
+#
+# This file is part of shcgi.
+# 
+# shcgi is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+# 
+# shcgi is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU Affero General Public License for more details.
+# 
+# You should have received a copy of the GNU Affero General Public License
+# along with shcgi.  If not, see <http://www.gnu.org/licenses/>. 
+
+if [ "$1" = '--server' ]; then
+  shift 1
+  ncat -klc "$call --ncat" $@
+  exit $?
+fi
+
+export REMOTE_ADDR="${NCAT_REMOTE_ADDR}"
+export SERVER_NAME="${NCAT_LOCAL_ADDR}"
+export SERVER_PORT="${NCAT_LOCAL_PORT}"
+
+eval $(
+sed -unr '
+  w/dev/stderr
+  /^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$/{
+    h
+    s;^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;export REQUEST_METHOD='\''\1'\'';p
+    g
+    s;^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;\2;
+    s;'\'';'\''\\'\'''\'';g
+    s;^.*$;export PATH_INFO='\''&'\'';p
+    g
+    s;^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;\3;
+    s;'\'';'\''\\'\'''\'';g
+    s;^.*$;export QUERY_STRING='\''&'\'';p
+    g
+    s;^(GET|HEAD|POST) ([^\?]*)\??(.+)? (HTTP\/[0-9]\.[0-9])\r?$;export SERVER_PROTOCOL='\''\4'\'';p
+    g
+  }
+
+  /^[Pp][Rr][Oo][Xx][Yy]: /d
+
+  /^[a-zA-Z_-]+: .*$/{
+    h
+    s;^[^:]+: (.*)\r$;\1;
+    s;'\'';'\''\\'\'''\'';g
+    s;^.*$;'\''&'\'';
+    x
+    s;: .*$;;
+    y;abcdefghijklmnopqrstuvwxyz-;ABCDEFGHIJKLMNOPQRSTUVWXYZ_;
+    s;^.+$;export HTTP_&=;
+    G
+    s;\n;;
+    p
+  }
+  /^\r?$/q
+'
+)
+
+HTTP_format(){
+  LC_ALL=C sed -rn '
+  :A
+  /^\r?$/!{H;n;bA}
+  
+  g
+  s;^(\r?\n)*;;
+  aConnection: close\r\n\r
+  /^HTTP\/[0-9]\.[0-9] [1-5][0-9][0-9] .*/bX
+  s;^(.+\n)?Location: .*$;HTTP/1.1 302 Found\r\n&;
+  s;^(.+\n)?Content-Type: .*$;HTTP/1.1 200 OK\r\n&;
+  
+  :X
+  p
+  $q
+  n
+  bX
+  '
+}